      subroutine mod_change_mon_name(mon,ir,ich)
      implicit none
      include 'atom_com.fh'
      integer ir,ich
      character mon*(*)
c
c---local
      integer im
c
c---  body
      if(mod_n.le.0) return
      do im=1,mod_n
         if(mod_ires(im).eq.ir.and.
     &        mod_ichn(im).eq.ich.and.
     &        trim(mod_rnam(im)).ne.'.'.and.
     &        trim(mod_rnam_new(im)).eq.trim(mon)) then
            mon = mod_rnam(im)
            goto 100
         endif
      enddo
 100  continue
      return
      end
c
      subroutine vdw_remove_intraresidue(vdwfile)
      implicit none
      include 'atom_com.fh'
      character vdwfile*(*)

c
      integer ia1,ia2,ires1,ires2,ich1,ich2
      integer insf1,insf2
      character atom1*4,atom2*4,mon1*8,mon2*8
      character achem1*2,achem2*2,asymb1*2,asymb2*2
      character ss*1,user*1
c
      integer ierr
      integer id,nvdw,nvdw1,sum_sym
      integer ivfile
      integer, allocatable :: ia_1(:,:)
      integer, allocatable :: nvdw_s(:,:)
      integer, allocatable :: vdw_flag(:)
c
c---  body
      call open_unform_file(ivfile,vdwfile,ierr)
      read(ivfile)nvdw
      allocate(ia_1(2,nvdw))
      allocate(nvdw_s(4,nvdw))
      allocate(vdw_flag(nvdw))
      vdw_flag(1:nvdw) = 0
      do id=1,nvdw
         read(ivfile)ia_1(1:2,id),nvdw_s(1:4,id)
      enddo
      do id=1,nvdw
         ia1 = ia_1(1,id)
         ia2 = ia_1(2,id)
         ires1 = i_resid(ia1)
         ires2 = i_resid(ia2)
         ich1 = i_chain(ires1)
         ich2 = i_chain(ires2)
         mon1 = res_name(ires1)
         mon2 = res_name(ires2)
         atom1 = atm_name(ia1)
         atom2 = atm_name(ia2)
         achem1 = atm_chem(ia1)
         achem2 = atm_chem(ia2)
         call mod_change_mon_name(mon1,ires1,ich1)
         call mod_change_mon_name(mon2,ires2,ich2)

         insf1 = id_sf(ia1)
         insf2 = id_sf(ia2)
         asymb1 = cs_atype(insf1)
         asymb2 = cs_atype(insf2)
         sum_sym = sum(abs(nvdw_s(1:4,id)))
         if((ich1.ne.ich2.or.ires1.ne.ires2).and.
     &        atm_type(ia1).ne.'M'.and.
     &        atm_type(ia1).ne.'U'.and.
     &        atm_type(ia1).ne.'D'.and.
     &        atm_type(ia2).ne.'M'.and.
     &        atm_type(ia2).ne.'U'.and.
     &        atm_type(ia2).ne.'D'.and.
     &        mon1.ne.'HOH'.and.mon1.ne.'DUM'.and.
     &        mon2.ne.'HOH'.and.mon2.ne.'DUM'.and.
     &        asymb1.ne.'H '.and.asymb2.ne.'H '.and.
     &        sum_sym.eq.0) then
            vdw_flag(id) = 1
            nvdw1 = nvdw1 + 1
         endif
c
c---  If connectivity then remove it
         if(vdw_flag(id).eq.1) then
            if(ich1.eq.ich2.and.(ires_forw(ires1).eq.ires2.or.
     &           ires_forw(ires2).eq.ires1))  then
               call is_it_ss(atom1,atom2,mon1,mon2,ss)
               if(ss.ne.'Y'.and.vdw_flag(id).eq.1) then
                  vdw_flag(id) = 0
                  nvdw1 = nvdw1 - 1
               endif
            endif
         endif
         if(vdw_flag(id).eq.1) then
c
c---Is there a user defined link between these residues
            call is_user_link(ia_1(1,id),ia_1(2,id),ires1,ires2,ich1,
     &           ich2,mon1,mon2,atom1,atom2,user)
            if(user.eq.'Y') then
               vdw_flag(id) = 0
               nvdw1 = nvdw1 - 1
            endif
         endif
      enddo
      close(ivfile)
      call open_unform_file(ivfile,vdwfile,ierr)
c
c---Write remaining pairs into the output file      
      write(ivfile)nvdw1
      do id=1,nvdw
         if(vdw_flag(id).eq.1) then
            write(ivfile)ia_1(1:2,id),nvdw_s(1:3,id)
         endif
      enddo
      close(ivfile)
      deallocate(ia_1)
      deallocate(nvdw_s)
      deallocate(vdw_flag)

      return
      end

      subroutine is_it_ss(atom1,atom2,mon1,mon2,ss)
      implicit none
      character ss*1
      character atom1*(*),atom2*(*),mon1*(*),mon2*(*)

      ss = 'N'
      if(trim(adjustl(atom1)).eq.'SG'.and.
     &     trim(adjustl(atom2)).eq.'SG'.and.
     &     trim(adjustl(mon1)).eq.'CYS'.and.
     &     trim(adjustl(mon2)).eq.'CYS') ss = 'Y'

      return
      end
c
      subroutine is_user_link(ln_n_init,ia1,ia2,ires1,ires2,ich1,ich2,
     &  mon1,mon2,atom1,atom2,user)
      implicit none
      include 'atom_com.fh'
c
      integer ln_n_init
      integer ia1,ia2,ires1,ires2,ich1,ich2
      character user*1
      character mon1*(*),mon2*(*),atom1*(*),atom2*(*)
c
c---  locals
      integer il
c
c---  body
      user = 'N'
      if(ln_n_init.le.0) return
      do il=1,ln_n_init
         if(ln_1ires(il).eq.ires1.and.ln_2ires(il).eq.ires2.and.
     &        ln_1ichn(il).eq.ich1.and.ln_2ichn(il).eq.ich2.or.
     &        ln_2ires(il).eq.ires1.and.ln_1ires(il).eq.ires2.and.
     &        ln_2ichn(il).eq.ich1.and.ln_1ichn(il).eq.ich2) then
            user = 'Y'
            goto 100
         endif
      enddo
 100  continue
      return
      end
c
      subroutine is_it_sugar(ilink,sug)
      implicit none
      include 'link_com.fh'
      include 'lib_com.fh'
      integer ilink
      character sug*(*)

      sug = 'N'
      if(lll_type1(ilink).eq.'pyranose'.and.
     &     lll_type2(ilink).eq.'pyranose'.or.
     &     lll_type1(ilink).eq.'pyranose'.and.
     &     lll_type2(ilink).eq.'peptide'.or.
     &     lll_type1(ilink).eq.'peptide'.and.
     &     lll_type2(ilink).eq.'pyranose') sug = 'Y'

      return
      end
